/*===========================================================================*/
/*   (Llib/tvector.scm)                                                      */
/*   Bigloo (2.6b)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 15 12:14:36 CET 2003        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -O4 -mklib -cc gcc-2.95 -fsharing -q -s -copt -DBGL_NO_PIC -unsafe -c Llib/tvector.scm -indent -o objs/obj_u/Llib/tvector.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <signal.h>

BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
extern obj_t BGl_bigloozd2casezd2sensitivityz00zz__readerz00();
extern obj_t create_struct(obj_t, int);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern long bgl_list_length(obj_t);
static obj_t BGl__declarezd2tvectorz12zc0zz__tvectorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__tvectorz00();
static obj_t BGl_symbol1833z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol1832z00zz__tvectorz00 = BUNSPEC;
static obj_t BGl_symbol1831z00zz__tvectorz00 = BUNSPEC;
extern obj_t string_to_symbol(char *);
extern obj_t BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_declarezd2tvectorz12zc0zz__tvectorz00(char *, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2ze3vectorz31zz__tvectorz00(obj_t);
extern obj_t BGl_stringzd2upcasezd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl__tvectorzd2refzd2zz__tvectorz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__tvectorz00();
BGL_EXPORTED_DECL obj_t BGl_vectorzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_tvectorzf3zf3zz__tvectorz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__tvectorz00 = BUNSPEC;
static obj_t BGl__tvectorzf3zf3zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2idzd2zz__tvectorz00(obj_t);
static obj_t BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = BUNSPEC;
extern obj_t string_to_bstring(char *);
BGL_EXPORTED_DECL obj_t BGl_listzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t);
static obj_t BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00(obj_t, obj_t);
extern bool_t BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl__vectorzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t get_tvector_descriptor(obj_t);
static obj_t BGl__listzd2ze3tvectorz31zz__tvectorz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_tvectorzd2refzd2zz__tvectorz00(obj_t);
static obj_t BGl__tvectorzd2idzd2zz__tvectorz00(obj_t, obj_t);
BGL_EXPORTED_DECL int BGl_tvectorzd2lengthzd2zz__tvectorz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__tvectorz00();
static obj_t BGl__tvectorzd2lengthzd2zz__tvectorz00(obj_t, obj_t);
static obj_t BGl__tvectorzd2ze3vectorz31zz__tvectorz00(obj_t, obj_t);
static obj_t *__cnst;


DEFINE_EXPORT_PROCEDURE( BGl_tvectorzd2lengthzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2lengthza7d2za7za7__tvectorza7001845za7, BGl__tvectorzd2lengthzd2zz__tvectorz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_tvectorzd2ze3vectorzd2envze3zz__tvectorz00, BgL_bgl__tvectorza7d2za7e3vectorza731za7za7__tvectorza7001846z00, BGl__tvectorzd2ze3vectorz31zz__tvectorz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_declarezd2tvectorz12zd2envz12zz__tvectorz00, BgL_bgl__declareza7d2tvectorza712za7c0za7za7__tvectorza7001847z00, BGl__declarezd2tvectorz12zc0zz__tvectorz00, 0L, 4 );
DEFINE_EXPORT_PROCEDURE( BGl_tvectorzd2refzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2refza7d2za7za7__tvectorza7001848za7, BGl__tvectorzd2refzd2zz__tvectorz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_tvectorzf3zd2envz21zz__tvectorz00, BgL_bgl__tvectorza7f3za7f3za7za7__tvectorza7001849za7, BGl__tvectorzf3zf3zz__tvectorz00, 0L, 1 );
DEFINE_STRING( BGl_string1838z00zz__tvectorz00, BgL_bgl_string1838za700za7za7__tvectorza7001850z00, "tvector->vector", 15 );
DEFINE_STRING( BGl_string1837z00zz__tvectorz00, BgL_bgl_string1837za700za7za7__tvectorza7001851z00, "vector->tvector", 15 );
DEFINE_STRING( BGl_string1836z00zz__tvectorz00, BgL_bgl_string1836za700za7za7__tvectorza7001852z00, "Undeclared tvector", 18 );
DEFINE_STRING( BGl_string1835z00zz__tvectorz00, BgL_bgl_string1835za700za7za7__tvectorza7001853z00, "Unable to convert to such tvector", 33 );
DEFINE_STRING( BGl_string1834z00zz__tvectorz00, BgL_bgl_string1834za700za7za7__tvectorza7001854z00, "list->tvector", 13 );
DEFINE_EXPORT_PROCEDURE( BGl_tvectorzd2idzd2envz00zz__tvectorz00, BgL_bgl__tvectorza7d2idza7d2za7za7__tvectorza7001855za7, BGl__tvectorzd2idzd2zz__tvectorz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_getzd2tvectorzd2descriptorzd2envzd2zz__tvectorz00, BgL_bgl__getza7d2tvectorza7d2descriptorza700za7za7__tvectorza7001856z00, BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_vectorzd2ze3tvectorzd2envze3zz__tvectorz00, BgL_bgl__vectorza7d2za7e3tvectorza731za7za7__tvectorza7001857z00, BGl__vectorzd2ze3tvectorz31zz__tvectorz00, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_listzd2ze3tvectorzd2envze3zz__tvectorz00, BgL_bgl__listza7d2za7e3tvectorza731za7za7__tvectorza7001858z00, BGl__listzd2ze3tvectorz31zz__tvectorz00, 0L, 2 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long BgL_checksumz00_819, char * BgL_fromz00_820)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__tvectorz00))
{ 
BGl_requirezd2initializa7ationz75zz__tvectorz00 = 
BBOOL(((bool_t)0)); 
BGl_cnstzd2initzd2zz__tvectorz00(); 
BGl_importedzd2moduleszd2initz00zz__tvectorz00(); 
BGl_toplevelzd2initzd2zz__tvectorz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 14 */
BGl_symbol1831z00zz__tvectorz00 = 
string_to_symbol("upcase"); 
BGl_symbol1832z00zz__tvectorz00 = 
string_to_symbol("downcase"); 
return ( 
BGl_symbol1833z00zz__tvectorz00 = 
string_to_symbol("tvect-descr"), BUNSPEC) ;} 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__tvectorz00()
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 14 */
return ( 
BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = BNIL, BUNSPEC) ;} 
}



/* tvector? */
BGL_EXPORTED_DEF bool_t BGl_tvectorzf3zf3zz__tvectorz00(obj_t BgL_objz00_1)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 85 */
return 
TVECTORP(BgL_objz00_1);} 
}



/* _tvector? */
obj_t BGl__tvectorzf3zf3zz__tvectorz00(obj_t BgL_envz00_793, obj_t BgL_objz00_794)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 85 */
{ /* ./Llib/tvector.scm 86 */
bool_t BgL_auxz00_831;
BgL_auxz00_831 = 
TVECTORP(BgL_objz00_794); 
return 
BBOOL(BgL_auxz00_831);} } 
}



/* tvector-length */
BGL_EXPORTED_DEF int BGl_tvectorzd2lengthzd2zz__tvectorz00(obj_t BgL_objz00_2)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 91 */
return 
TVECTOR_LENGTH(BgL_objz00_2);} 
}



/* _tvector-length */
obj_t BGl__tvectorzd2lengthzd2zz__tvectorz00(obj_t BgL_envz00_795, obj_t BgL_objz00_796)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 91 */
{ /* ./Llib/tvector.scm 92 */
int BgL_auxz00_835;
BgL_auxz00_835 = 
TVECTOR_LENGTH(BgL_objz00_796); 
return 
BINT(BgL_auxz00_835);} } 
}



/* tvector-id */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2idzd2zz__tvectorz00(obj_t BgL_tvectz00_3)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 97 */
{ /* ./Llib/tvector.scm 98 */
int BgL_auxz00_840;obj_t BgL_auxz00_838;
BgL_auxz00_840 = 
(int)(((long)0)); 
BgL_auxz00_838 = 
TVECTOR_DESCR(BgL_tvectz00_3); 
return 
STRUCT_REF(BgL_auxz00_838, BgL_auxz00_840);} } 
}



/* _tvector-id */
obj_t BGl__tvectorzd2idzd2zz__tvectorz00(obj_t BgL_envz00_797, obj_t BgL_tvectz00_798)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 97 */
return 
BGl_tvectorzd2idzd2zz__tvectorz00(BgL_tvectz00_798);} 
}



/* get-tvector-descriptor */
BGL_EXPORTED_DEF obj_t get_tvector_descriptor(obj_t BgL_idz00_22)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 120 */
if(
PAIRP(BGl_za2tvectorzd2tableza2zd2zz__tvectorz00))
{ /* ./Llib/tvector.scm 121 */
obj_t BgL_cellz00_629;
BgL_cellz00_629 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_22, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); 
if(
PAIRP(BgL_cellz00_629))
{ /* ./Llib/tvector.scm 121 */
return 
CDR(BgL_cellz00_629);}  else 
{ /* ./Llib/tvector.scm 121 */
return BFALSE;} }  else 
{ /* ./Llib/tvector.scm 121 */
return BFALSE;} } 
}



/* _get-tvector-descriptor */
obj_t BGl__getzd2tvectorzd2descriptorz00zz__tvectorz00(obj_t BgL_envz00_799, obj_t BgL_idz00_800)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 120 */
return 
get_tvector_descriptor(BgL_idz00_800);} 
}



/* declare-tvector! */
BGL_EXPORTED_DEF obj_t BGl_declarezd2tvectorz12zc0zz__tvectorz00(char * BgL_idz00_23, obj_t BgL_allocatez00_24, obj_t BgL_refz00_25, obj_t BgL_setz00_26)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 134 */
{ /* ./Llib/tvector.scm 135 */
obj_t BgL_idz00_384;
{ /* ./Llib/tvector.scm 135 */
obj_t BgL_arg1061z00_389;
{ /* ./Llib/tvector.scm 135 */
obj_t BgL_casezd2valuezd2_390;
BgL_casezd2valuezd2_390 = 
BGl_bigloozd2casezd2sensitivityz00zz__readerz00(); 
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_casezd2valuezd2_390, BGl_symbol1831z00zz__tvectorz00))
{ /* ./Llib/tvector.scm 135 */
BgL_arg1061z00_389 = 
BGl_stringzd2upcasezd2zz__r4_strings_6_7z00(
string_to_bstring(BgL_idz00_23)); }  else 
{ /* ./Llib/tvector.scm 135 */
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_casezd2valuezd2_390, BGl_symbol1832z00zz__tvectorz00))
{ /* ./Llib/tvector.scm 135 */
BgL_arg1061z00_389 = 
BGl_stringzd2downcasezd2zz__r4_strings_6_7z00(
string_to_bstring(BgL_idz00_23)); }  else 
{ /* ./Llib/tvector.scm 135 */
BgL_arg1061z00_389 = 
string_to_bstring(BgL_idz00_23); } } } 
{ /* ./Llib/tvector.scm 135 */
char * BgL_auxz00_861;
BgL_auxz00_861 = 
BSTRING_TO_STRING(BgL_arg1061z00_389); 
BgL_idz00_384 = 
string_to_symbol(BgL_auxz00_861); } } 
{ /* ./Llib/tvector.scm 135 */
obj_t BgL_oldz00_385;
if(
PAIRP(BGl_za2tvectorzd2tableza2zd2zz__tvectorz00))
{ /* ./Llib/tvector.scm 142 */
obj_t BgL_cellz00_637;
BgL_cellz00_637 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_384, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); 
if(
PAIRP(BgL_cellz00_637))
{ /* ./Llib/tvector.scm 142 */
BgL_oldz00_385 = 
CDR(BgL_cellz00_637); }  else 
{ /* ./Llib/tvector.scm 142 */
BgL_oldz00_385 = BFALSE; } }  else 
{ /* ./Llib/tvector.scm 142 */
BgL_oldz00_385 = BFALSE; } 
{ /* ./Llib/tvector.scm 142 */

{ /* ./Llib/tvector.scm 143 */
bool_t BgL_test1052z00_386;
if(
STRUCTP(BgL_oldz00_385))
{ /* ./Llib/tvector.scm 143 */
obj_t BgL_auxz00_872;
BgL_auxz00_872 = 
STRUCT_KEY(BgL_oldz00_385); 
BgL_test1052z00_386 = 
(BgL_auxz00_872==BGl_symbol1833z00zz__tvectorz00); }  else 
{ /* ./Llib/tvector.scm 143 */
BgL_test1052z00_386 = ((bool_t)0); } 
if(BgL_test1052z00_386)
{ /* ./Llib/tvector.scm 143 */
return BgL_oldz00_385;}  else 
{ /* ./Llib/tvector.scm 144 */
obj_t BgL_newz00_387;
{ /* ./Llib/tvector.scm 144 */
obj_t BgL_newz00_653;
{ /* ./Llib/tvector.scm 144 */
int BgL_auxz00_876;
BgL_auxz00_876 = 
(int)(((long)4)); 
BgL_newz00_653 = 
create_struct(BGl_symbol1833z00zz__tvectorz00, BgL_auxz00_876); } 
{ /* ./Llib/tvector.scm 144 */
int BgL_auxz00_879;
BgL_auxz00_879 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_653, BgL_auxz00_879, BgL_setz00_26); } 
{ /* ./Llib/tvector.scm 144 */
int BgL_auxz00_882;
BgL_auxz00_882 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_653, BgL_auxz00_882, BgL_refz00_25); } 
{ /* ./Llib/tvector.scm 144 */
int BgL_auxz00_885;
BgL_auxz00_885 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_653, BgL_auxz00_885, BgL_allocatez00_24); } 
{ /* ./Llib/tvector.scm 144 */
int BgL_auxz00_888;
BgL_auxz00_888 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_653, BgL_auxz00_888, BgL_idz00_384); } 
BgL_newz00_387 = BgL_newz00_653; } 
{ /* ./Llib/tvector.scm 145 */
obj_t BgL_arg1054z00_388;
BgL_arg1054z00_388 = 
MAKE_PAIR(BgL_idz00_384, BgL_newz00_387); 
BGl_za2tvectorzd2tableza2zd2zz__tvectorz00 = 
MAKE_PAIR(BgL_arg1054z00_388, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); } 
return BgL_newz00_387;} } } } } } 
}



/* _declare-tvector! */
obj_t BGl__declarezd2tvectorz12zc0zz__tvectorz00(obj_t BgL_envz00_801, obj_t BgL_idz00_802, obj_t BgL_allocatez00_803, obj_t BgL_refz00_804, obj_t BgL_setz00_805)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 134 */
return 
BGl_declarezd2tvectorz12zc0zz__tvectorz00(
BSTRING_TO_STRING(BgL_idz00_802), BgL_allocatez00_803, BgL_refz00_804, BgL_setz00_805);} 
}



/* tvector-ref */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2refzd2zz__tvectorz00(obj_t BgL_tvectorz00_27)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 152 */
{ /* ./Llib/tvector.scm 153 */
int BgL_auxz00_897;obj_t BgL_auxz00_895;
BgL_auxz00_897 = 
(int)(((long)2)); 
BgL_auxz00_895 = 
TVECTOR_DESCR(BgL_tvectorz00_27); 
return 
STRUCT_REF(BgL_auxz00_895, BgL_auxz00_897);} } 
}



/* _tvector-ref */
obj_t BGl__tvectorzd2refzd2zz__tvectorz00(obj_t BgL_envz00_806, obj_t BgL_tvectorz00_807)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 152 */
return 
BGl_tvectorzd2refzd2zz__tvectorz00(BgL_tvectorz00_807);} 
}



/* list->tvector */
BGL_EXPORTED_DEF obj_t BGl_listzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_idz00_28, obj_t BgL_lz00_29)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 158 */
{ /* ./Llib/tvector.scm 159 */
obj_t BgL_descrz00_396;
if(
PAIRP(BGl_za2tvectorzd2tableza2zd2zz__tvectorz00))
{ /* ./Llib/tvector.scm 159 */
obj_t BgL_cellz00_680;
BgL_cellz00_680 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_28, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); 
if(
PAIRP(BgL_cellz00_680))
{ /* ./Llib/tvector.scm 159 */
BgL_descrz00_396 = 
CDR(BgL_cellz00_680); }  else 
{ /* ./Llib/tvector.scm 159 */
BgL_descrz00_396 = BFALSE; } }  else 
{ /* ./Llib/tvector.scm 159 */
BgL_descrz00_396 = BFALSE; } 
if(
CBOOL(BgL_descrz00_396))
{ /* ./Llib/tvector.scm 162 */
obj_t BgL_allocatez00_397;obj_t BgL_setz00_398;
{ /* ./Llib/tvector.scm 162 */
int BgL_auxz00_909;
BgL_auxz00_909 = 
(int)(((long)1)); 
BgL_allocatez00_397 = 
STRUCT_REF(BgL_descrz00_396, BgL_auxz00_909); } 
{ /* ./Llib/tvector.scm 163 */
int BgL_auxz00_912;
BgL_auxz00_912 = 
(int)(((long)3)); 
BgL_setz00_398 = 
STRUCT_REF(BgL_descrz00_396, BgL_auxz00_912); } 
if(
PROCEDUREP(BgL_setz00_398))
{ /* ./Llib/tvector.scm 168 */
long BgL_lenz00_400;
BgL_lenz00_400 = 
bgl_list_length(BgL_lz00_29); 
{ /* ./Llib/tvector.scm 168 */
obj_t BgL_tvecz00_401;
BgL_tvecz00_401 = 
PROCEDURE_ENTRY(BgL_allocatez00_397)(BgL_allocatez00_397, 
BINT(BgL_lenz00_400), BEOA); 
{ /* ./Llib/tvector.scm 169 */

{ 
obj_t BgL_lz00_693;long BgL_iz00_694;
BgL_lz00_693 = BgL_lz00_29; 
BgL_iz00_694 = ((long)0); 
BgL_loopz00_692:
if(
NULLP(BgL_lz00_693))
{ /* ./Llib/tvector.scm 170 */
return BgL_tvecz00_401;}  else 
{ /* ./Llib/tvector.scm 170 */
{ /* ./Llib/tvector.scm 170 */
obj_t BgL_arg1088z00_700;
BgL_arg1088z00_700 = 
CAR(BgL_lz00_693); 
PROCEDURE_ENTRY(BgL_setz00_398)(BgL_setz00_398, BgL_tvecz00_401, 
BINT(BgL_iz00_694), BgL_arg1088z00_700, BEOA); } 
{ 
long BgL_iz00_929;obj_t BgL_lz00_927;
BgL_lz00_927 = 
CDR(BgL_lz00_693); 
BgL_iz00_929 = 
(BgL_iz00_694+((long)1)); 
BgL_iz00_694 = BgL_iz00_929; 
BgL_lz00_693 = BgL_lz00_927; 
goto BgL_loopz00_692;} } } } } }  else 
{ /* ./Llib/tvector.scm 164 */
FAILURE(BGl_string1834z00zz__tvectorz00,BGl_string1835z00zz__tvectorz00,BgL_idz00_28);} }  else 
{ /* ./Llib/tvector.scm 160 */
FAILURE(BGl_string1834z00zz__tvectorz00,BGl_string1836z00zz__tvectorz00,BgL_idz00_28);} } } 
}



/* _list->tvector */
obj_t BGl__listzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_envz00_808, obj_t BgL_idz00_809, obj_t BgL_lz00_810)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 158 */
return 
BGl_listzd2ze3tvectorz31zz__tvectorz00(BgL_idz00_809, BgL_lz00_810);} 
}



/* vector->tvector */
BGL_EXPORTED_DEF obj_t BGl_vectorzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_idz00_30, obj_t BgL_vz00_31)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 181 */
{ /* ./Llib/tvector.scm 182 */
obj_t BgL_descrz00_409;
if(
PAIRP(BGl_za2tvectorzd2tableza2zd2zz__tvectorz00))
{ /* ./Llib/tvector.scm 182 */
obj_t BgL_cellz00_736;
BgL_cellz00_736 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_idz00_30, BGl_za2tvectorzd2tableza2zd2zz__tvectorz00); 
if(
PAIRP(BgL_cellz00_736))
{ /* ./Llib/tvector.scm 182 */
BgL_descrz00_409 = 
CDR(BgL_cellz00_736); }  else 
{ /* ./Llib/tvector.scm 182 */
BgL_descrz00_409 = BFALSE; } }  else 
{ /* ./Llib/tvector.scm 182 */
BgL_descrz00_409 = BFALSE; } 
if(
CBOOL(BgL_descrz00_409))
{ /* ./Llib/tvector.scm 185 */
obj_t BgL_allocatez00_410;obj_t BgL_setz00_411;
{ /* ./Llib/tvector.scm 185 */
int BgL_auxz00_942;
BgL_auxz00_942 = 
(int)(((long)1)); 
BgL_allocatez00_410 = 
STRUCT_REF(BgL_descrz00_409, BgL_auxz00_942); } 
{ /* ./Llib/tvector.scm 186 */
int BgL_auxz00_945;
BgL_auxz00_945 = 
(int)(((long)3)); 
BgL_setz00_411 = 
STRUCT_REF(BgL_descrz00_409, BgL_auxz00_945); } 
if(
PROCEDUREP(BgL_setz00_411))
{ /* ./Llib/tvector.scm 191 */
int BgL_lenz00_413;
BgL_lenz00_413 = 
VECTOR_LENGTH(BgL_vz00_31); 
{ /* ./Llib/tvector.scm 191 */
obj_t BgL_tvecz00_414;
BgL_tvecz00_414 = 
PROCEDURE_ENTRY(BgL_allocatez00_410)(BgL_allocatez00_410, 
BINT(BgL_lenz00_413), BEOA); 
{ /* ./Llib/tvector.scm 192 */

{ 
long BgL_iz00_415;
{ /* ./Llib/tvector.scm 193 */
long BgL_auxz00_964;
BgL_auxz00_964 = 
(long)(BgL_lenz00_413); 
BgL_iz00_415 = 
(BgL_auxz00_964-((long)1)); } 
BgL_loopz00_416:
if(
(BgL_iz00_415==((long)-1)))
{ /* ./Llib/tvector.scm 194 */
return BgL_tvecz00_414;}  else 
{ /* ./Llib/tvector.scm 194 */
{ /* ./Llib/tvector.scm 197 */
obj_t BgL_arg1113z00_419;
{ 
int BgL_auxz00_956;
BgL_auxz00_956 = 
(int)(BgL_iz00_415); 
BgL_arg1113z00_419 = 
VECTOR_REF(BgL_vz00_31,BgL_auxz00_956); } 
PROCEDURE_ENTRY(BgL_setz00_411)(BgL_setz00_411, BgL_tvecz00_414, 
BINT(BgL_iz00_415), BgL_arg1113z00_419, BEOA); } 
{ 
long BgL_iz00_962;
BgL_iz00_962 = 
(BgL_iz00_415-((long)1)); 
BgL_iz00_415 = BgL_iz00_962; 
goto BgL_loopz00_416;} } } } } }  else 
{ /* ./Llib/tvector.scm 187 */
FAILURE(BGl_string1837z00zz__tvectorz00,BGl_string1835z00zz__tvectorz00,BgL_idz00_30);} }  else 
{ /* ./Llib/tvector.scm 183 */
FAILURE(BGl_string1837z00zz__tvectorz00,BGl_string1836z00zz__tvectorz00,BgL_idz00_30);} } } 
}



/* _vector->tvector */
obj_t BGl__vectorzd2ze3tvectorz31zz__tvectorz00(obj_t BgL_envz00_811, obj_t BgL_idz00_812, obj_t BgL_vz00_813)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 181 */
return 
BGl_vectorzd2ze3tvectorz31zz__tvectorz00(BgL_idz00_812, BgL_vz00_813);} 
}



/* tvector->vector */
BGL_EXPORTED_DEF obj_t BGl_tvectorzd2ze3vectorz31zz__tvectorz00(obj_t BgL_tvz00_32)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 203 */
{ /* ./Llib/tvector.scm 204 */
obj_t BgL_descrz00_421;
BgL_descrz00_421 = 
TVECTOR_DESCR(BgL_tvz00_32); 
{ /* ./Llib/tvector.scm 205 */
obj_t BgL_refz00_423;
{ /* ./Llib/tvector.scm 206 */
int BgL_auxz00_971;
BgL_auxz00_971 = 
(int)(((long)2)); 
BgL_refz00_423 = 
STRUCT_REF(BgL_descrz00_421, BgL_auxz00_971); } 
if(
PROCEDUREP(BgL_refz00_423))
{ /* ./Llib/tvector.scm 211 */
int BgL_lenz00_425;
BgL_lenz00_425 = 
TVECTOR_LENGTH(BgL_tvz00_32); 
{ /* ./Llib/tvector.scm 211 */
obj_t BgL_vecz00_426;
BgL_vecz00_426 = 
create_vector(BgL_lenz00_425); 
{ /* ./Llib/tvector.scm 212 */

{ 
long BgL_iz00_427;
{ /* ./Llib/tvector.scm 213 */
long BgL_auxz00_988;
BgL_auxz00_988 = 
(long)(BgL_lenz00_425); 
BgL_iz00_427 = 
(BgL_auxz00_988-((long)1)); } 
BgL_loopz00_428:
if(
(BgL_iz00_427==((long)-1)))
{ /* ./Llib/tvector.scm 214 */
return BgL_vecz00_426;}  else 
{ /* ./Llib/tvector.scm 214 */
{ /* ./Llib/tvector.scm 217 */
obj_t BgL_arg1136z00_431;
BgL_arg1136z00_431 = 
PROCEDURE_ENTRY(BgL_refz00_423)(BgL_refz00_423, BgL_tvz00_32, 
BINT(BgL_iz00_427), BEOA); 
{ 
int BgL_auxz00_983;
BgL_auxz00_983 = 
(int)(BgL_iz00_427); 
VECTOR_SET(BgL_vecz00_426,BgL_auxz00_983,BgL_arg1136z00_431); } } 
{ 
long BgL_iz00_986;
BgL_iz00_986 = 
(BgL_iz00_427-((long)1)); 
BgL_iz00_427 = BgL_iz00_986; 
goto BgL_loopz00_428;} } } } } }  else 
{ /* ./Llib/tvector.scm 208 */
obj_t BgL_arg1149z00_435;
{ /* ./Llib/tvector.scm 210 */
int BgL_auxz00_991;
BgL_auxz00_991 = 
(int)(((long)0)); 
BgL_arg1149z00_435 = 
STRUCT_REF(BgL_descrz00_421, BgL_auxz00_991); } 
FAILURE(BGl_string1838z00zz__tvectorz00,BGl_string1835z00zz__tvectorz00,BgL_arg1149z00_435);} } } } 
}



/* _tvector->vector */
obj_t BGl__tvectorzd2ze3vectorz31zz__tvectorz00(obj_t BgL_envz00_814, obj_t BgL_tvz00_815)
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 203 */
return 
BGl_tvectorzd2ze3vectorz31zz__tvectorz00(BgL_tvz00_815);} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__tvectorz00()
{ AN_OBJECT;
{ /* ./Llib/tvector.scm 14 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)11084), "__tvector"); 
return 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)62825), "__tvector");} 
}

